import numpy as np




# Order 2 scheme




# Return a specific square matrix. T is the size, d the number on the diagonal and the only non zeros non diagonal terms are +/- s
def Z(T,d,s):
    vs = s*np.ones(T-1)
    vd = d*np.ones(T)
    M = np.diag(vd) + np.diag(vs,1) - np.diag(vs,-1)
    M[0,T-1] = -s
    M[T-1,0] = s
    return M;


# Return a specific vector for the second member. T is the size, R an adimentionnal member (parameter of the function). x, y and z are vectors of size T.
def F(T,Nr,Nk,T0,Tur,Tbr):
    res = [     (3*T0[i]/Nr + 2*Tbr[i]/Nk)/(Tur[i]**2)          for i in np.arange(0,T,1)] 
   
    return res;



# Construction of the matrix of the linear equation for the Newton's method at each iteration. It is composed by 5x5 square matrices of size T
def Homogene(T, Nb, Nr, Nk, T01, T02, Xr):
    M = np.block([

    [2*np.diag((T01/Nr + Xr[2*T:3*T]/Nk)/(Xr[0:T]**3)),np.zeros((T,T)),-np.diag(1/(Xr[0:T]**2))/Nk,np.zeros((T,T)),Z(T,-(1/Nr+1/Nk),0.5*T)],  

    [np.zeros((T,T)),2*np.diag((T02/Nr + Xr[3*T:4*T]/Nk)/(Xr[T:2*T]**3)),np.zeros((T,T)),-np.diag(1/(Xr[T:2*T]**2)/Nk),Z(T,-(1/Nr+1/Nk),0.5*T)], 

    [-np.eye(T)/Nb,   np.zeros((T,T)),   Z(T,1/Nb,0.5*T),   np.zeros((T,T)),   np.zeros((T,T))],

    [np.zeros((T,T)),   -np.eye(T)/Nb,   np.zeros((T,T)),   Z(T,1/Nb,0.5*T),   np.zeros((T,T))],

    [Z(T,(1/Nr+1/Nk),0.5*T),   Z(T,(1/Nr+1/Nk),0.5*T),   -np.eye(T)/Nk,   -np.eye(T)/Nk,   np.zeros((T,T))] 

    ]) 
    return M;


# Construction of the second member of the linear equation for the Newton's method at each iteration. It is composed by 5x5 square matrices of size T
def SecondMember(T, Nr, Nk, T01, T02, Xr): 
    S = np.concatenate((F(T,Nr,Nk,T01,Xr[0:T],Xr[2*T:3*T]),   F(T,Nr,Nk,T02,Xr[T:2*T],Xr[3*T:4*T]),   np.zeros(2*T),  (T01+T02)/Nr))
    return S; 


















 







